package com.example.epl498_sensors;

import android.Manifest;
import android.content.pm.PackageManager;
import android.media.MediaPlayer;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import java.io.IOException;
import java.util.Map;

public class MicrophoneFragment extends Fragment {

    private Button btnRecord, btnPlay;
    private MediaRecorder mediaRecorder;
    private MediaPlayer mediaPlayer;
    private String outputFile;

    private boolean isRecording = false;

    private boolean permissionToRecordAccepted = false;
    private String[] permissions = {
            // TODO: assign the appropriate permission
    };

    private final ActivityResultLauncher<String[]> requestPermissionLauncher = registerForActivityResult(
            new ActivityResultContracts.RequestMultiplePermissions(),
            new ActivityResultCallback<Map<String, Boolean>>() {
                @Override
                public void onActivityResult(Map<String, Boolean> result) {
                    boolean allPermissionsGranted = true;
                    for (Boolean granted : result.values()) {
                        if (!granted) {
                            allPermissionsGranted = false;
                            break;
                        }
                    }
                    if (allPermissionsGranted) {
                        startRecording();
                    } else {
                        // TODO: Handle permission denial, exit app
                    }
                }
            }
    );

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_microphone, container, false);

	// TODO: get button record
        btnRecord = null;
        // TODO: get button play
        btnPlay = null;

        // Set up output file path
        outputFile = requireContext().getFilesDir() + "/audio.3gp";

        // TODO: set on click listener for button record
        
        // TODO: set on click listener for button play

        return view;
    }

    private boolean checkPermissions() {
        for (String permission : permissions) {
            if (ContextCompat.checkSelfPermission(getActivity(), permission) != PackageManager.PERMISSION_GRANTED) {
                return false;
            }
        }
        return true;
    }

    private void startRecording() {
        isRecording = true;
        // TODO: set record button's text to "Stop"
        btnRecord.setText("Stop");
        
        /** TODO: create mediaRecorder object
         * Set the source to: MIC 
         * The output format to: THREE_GPP
         * set output file to: outputFile
         * and the audio encoder to: AMR_NB
         */

        try {
            mediaRecorder.prepare();
        } catch (IOException e) {
            e.printStackTrace();
        }

        // TODO: start media recorder
    }

    private void stopRecording() {
        isRecording = false;
        // TODO: set record button's text to "Record"
        btnRecord.setText("Record");

        mediaRecorder.stop();
        mediaRecorder.release();
        mediaRecorder = null;
        // TODO: enable button play
        btnPlay.setEnabled(true);
    }

    private void playRecording() {
        mediaPlayer = new MediaPlayer();
        try {
            // TODO: set data source of media player to outputFile
            // TODO: prepare the media player
            // TODO: start media player

            // TODO: Disable the "Play" button while playing and change its text to "Playing audio.."

            // Use a Handler to update the button text when the audio is done playing
            mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {
                    // TODO: Re-enable the "Play" button and set the text back to "Play"
                }
            });
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        if (mediaRecorder != null) {
            mediaRecorder.release();
        }
        if (mediaPlayer != null) {
            mediaPlayer.release();
        }
    }
}

